-- boards.lua v1.1 -- Revised by Tallow
--
-- Run a set of sawmills to generate boards.
--

dofile("common.inc");

askText = singleLine([[
   Flower Fert from Talos
]]);

pause_time = 3000; 

function doit()
  askForWindow(askText);
  askForFocus();
  while true do
  	makeFlowerFert();
  end
end

function makeFlowerFert()
	-- Click pin ups to refresh the window
    clickAllImages("ThisIs.png");
    clickAllImages("KettleTake.png")
    sleepWithStatus(200, "Refreshing");

    clickAllImages("MakeFlowerFert.png");
    sleepWithStatus(300, "Refreshing");

    clickAllImages("KettleBegin.png"); 
    sleepWithStatus(1000, "Making Flower Fert");

    ready = false
    repeat 
    	srReadScreen();
    	sleepWithStatus(200, "Making Flower Fert");
		ready = srFindImage("KettleTake.png");
	until(ready)
	sleepWithStatus(2000, "Making Flower Fert (ready).");
	clickAllImages("KettleTake.png");

	drawWater(); 	
end