-- single_click_stat_mon.lua v1.1 -- Revised by Tallow
--
-- Repeatedly click a single location whenever stats are black.
--

dofile("common.inc");
SECS = 20

askText = singleLine([[
  Click on Plant Pappy
]]);


function doit()
  local mousePos = askForWindow(askText);

  local clickCount = 0;
  local lastClickTime = lsGetTimer();
  while 1 do
    lastClickTime = lsGetTimer();
    safeClick(mousePos[0], mousePos[1]);
    clickCount = clickCount + 1;
    message = "Clicking. ";
    message = message .. clickCount .. " clicks so far. ";
    sleepWithStatus(SECS*1000, message);
  end
end
